var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/effect/request.effect.ts
var RequestEffect = class {
  constructor(config) {
    this.config = config;
    this.getEffectKey = () => {
      return this.config.effectKey;
    };
    this.onTrigger = (request) => {
      var _a, _b;
      (_b = (_a = this.config).onTrigger) == null ? void 0 : _b.call(_a, request);
    };
    this.onStart = (request) => {
      var _a, _b;
      (_b = (_a = this.config).onStart) == null ? void 0 : _b.call(_a, request);
    };
    this.onSuccess = (response, request) => {
      var _a, _b;
      (_b = (_a = this.config).onSuccess) == null ? void 0 : _b.call(_a, response, request);
    };
    this.onError = (response, request) => {
      var _a, _b;
      (_b = (_a = this.config).onError) == null ? void 0 : _b.call(_a, response, request);
    };
    this.onFinished = (response, request) => {
      var _a, _b;
      (_b = (_a = this.config).onFinished) == null ? void 0 : _b.call(_a, response, request);
    };
  }
};

// src/constants/time.constants.ts
var DateInterval = /* @__PURE__ */ ((DateInterval2) => {
  DateInterval2[DateInterval2["second"] = 1e3] = "second";
  DateInterval2[DateInterval2["minute"] = 6e4] = "minute";
  DateInterval2[DateInterval2["hour"] = 36e5] = "hour";
  DateInterval2[DateInterval2["day"] = 864e5] = "day";
  DateInterval2[DateInterval2["week"] = 6048e5] = "week";
  DateInterval2[DateInterval2["month30"] = 2592e6] = "month30";
  DateInterval2[DateInterval2["month31"] = 26784e5] = "month31";
  DateInterval2[DateInterval2["year"] = 31536e6] = "year";
  DateInterval2[DateInterval2["yearLeap"] = 316224e5] = "yearLeap";
  return DateInterval2;
})(DateInterval || {});

// src/adapter/adapter.constants.ts
var defaultTimeout = 1e3 /* second */ * 5;
var xhrExtra = {
  headers: {}
};

// src/adapter/adapter.browser.ts
var adapter = (request, requestId) => __async(void 0, null, function* () {
  const {
    makeRequest,
    fullUrl,
    config,
    payload,
    headers,
    onError,
    onResponseEnd,
    onTimeoutError,
    onRequestEnd,
    createAbortListener,
    onResponseProgress,
    onRequestProgress,
    onResponseStart,
    onBeforeRequest,
    onRequestStart,
    onSuccess
  } = yield getAdapterBindings(request, requestId, 0, {
    headers: {}
  });
  const { method = "GET" } = request;
  return makeRequest((resolve) => {
    const xhr = new XMLHttpRequest();
    xhr.timeout = defaultTimeout;
    const abort = () => xhr.abort();
    Object.entries(config).forEach(([name, value]) => {
      xhr[name] = value;
    });
    xhr.open(method, fullUrl, true);
    Object.entries(headers).forEach(([name, value]) => xhr.setRequestHeader(name, value));
    const unmountListener = createAbortListener(0, xhrExtra, abort, resolve);
    xhr.upload.onprogress = onRequestProgress;
    xhr.onloadstart = () => {
      onRequestEnd();
      onResponseStart();
    };
    xhr.onprogress = onResponseProgress;
    xhr.onloadend = () => {
      onResponseEnd();
      unmountListener();
    };
    xhr.ontimeout = () => onTimeoutError(0, xhrExtra, resolve);
    xhr.onreadystatechange = (e) => {
      const event = e;
      const finishedState = 4;
      if (event.target && event.target.readyState === finishedState) {
        const { status } = event.target;
        const success = String(status).startsWith("2") || String(status).startsWith("3");
        const responseHeaders = getResponseHeaders(xhr.getAllResponseHeaders());
        if (success) {
          const data = parseResponse(event.target.response);
          onSuccess(data, status, { headers: responseHeaders }, resolve);
        } else {
          const data = parseErrorResponse(event.target.response);
          onError(data, status, { headers: responseHeaders }, resolve);
        }
      }
    };
    onBeforeRequest();
    onRequestStart();
    xhr.send(payload);
  });
});

// src/adapter/adapter.ts
var adapter2 = (request, requestId) => __async(void 0, null, function* () {
  if (typeof XMLHttpRequest !== "undefined") {
    return adapter(request, requestId);
  }
  return adapter(request, requestId);
});

// src/adapter/adapter.utils.ts
var getErrorMessage = (errorCase) => {
  if (errorCase === "timeout") {
    return new Error("Request timeout");
  }
  if (errorCase === "abort") {
    return new Error("Request cancelled");
  }
  return new Error("Unexpected error");
};
var getResponseHeaders = (headersString) => {
  const arr = headersString.trim().split(/[\r\n]+/);
  const headers = {};
  arr.forEach((line) => {
    const parts = line.split(": ");
    const header = parts.shift();
    const value = parts.join(": ");
    headers[header] = value;
  });
  return headers;
};
var parseResponse = (response) => {
  try {
    return JSON.parse(response);
  } catch (err) {
    return response;
  }
};
var parseErrorResponse = (response) => {
  return response ? parseResponse(response) : getErrorMessage();
};

// src/utils/uuid.utils.ts
var getUniqueRequestId = (key) => {
  return `${key}_${Date.now().toString(36)}_${Math.random().toString(36).substring(2)}`;
};

// src/request/request.ts
var Request = class {
  constructor(client, requestOptions, requestJSON) {
    this.client = client;
    this.requestOptions = requestOptions;
    this.requestJSON = requestJSON;
    this.isMockEnabled = false;
    this.setHeaders = (headers) => {
      return this.clone({ headers });
    };
    this.setAuth = (auth) => {
      return this.clone({ auth });
    };
    this.setParams = (params) => {
      return this.clone({ params });
    };
    this.setData = (data) => {
      return this.clone({
        data
      });
    };
    this.setQueryParams = (queryParams) => {
      return this.clone({ queryParams });
    };
    this.setOptions = (options) => {
      return this.clone({ options });
    };
    this.setCancelable = (cancelable) => {
      return this.clone({ cancelable });
    };
    this.setRetry = (retry) => {
      return this.clone({ retry });
    };
    this.setRetryTime = (retryTime) => {
      return this.clone({ retryTime });
    };
    this.setGarbageCollection = (garbageCollection) => {
      return this.clone({ garbageCollection });
    };
    this.setCache = (cache) => {
      return this.clone({ cache });
    };
    this.setCacheTime = (cacheTime) => {
      return this.clone({ cacheTime });
    };
    this.setQueued = (queued) => {
      return this.clone({ queued });
    };
    this.setAbortKey = (abortKey) => {
      this.updatedAbortKey = true;
      return this.clone({ abortKey });
    };
    this.setCacheKey = (cacheKey) => {
      this.updatedCacheKey = true;
      return this.clone({ cacheKey });
    };
    this.setQueueKey = (queueKey) => {
      this.updatedQueueKey = true;
      return this.clone({ queueKey });
    };
    this.setEffectKey = (effectKey) => {
      this.updatedEffectKey = true;
      return this.clone({ effectKey });
    };
    this.setDeduplicate = (deduplicate) => {
      return this.clone({ deduplicate });
    };
    this.setDeduplicateTime = (deduplicateTime) => {
      return this.clone({ deduplicateTime });
    };
    this.setUsed = (used) => {
      return this.clone({ used });
    };
    this.setOffline = (offline) => {
      return this.clone({ offline });
    };
    this.setMock = (mockData) => {
      const mockGenerator = function* mocked(mockedValues) {
        if (Array.isArray(mockData)) {
          let iteration = 0;
          while (true) {
            yield mockedValues[iteration];
            iteration = mockData.length === iteration + 1 ? 0 : iteration + 1;
          }
        } else {
          while (true) {
            yield mockData;
          }
        }
      };
      this.mockData = mockData;
      this.mock = mockGenerator(mockData);
      this.isMockEnabled = true;
      return this;
    };
    this.removeMock = () => {
      this.mockData = null;
      this.mock = null;
      this.isMockEnabled = false;
      return this;
    };
    this.setEnableMocking = (isMockEnabled) => {
      this.isMockEnabled = isMockEnabled;
      return this;
    };
    this.setDataMapper = (dataMapper) => {
      const cloned = this.clone(void 0);
      cloned.dataMapper = dataMapper;
      return cloned;
    };
    this.setRequestMapper = (requestMapper) => {
      const cloned = this.clone(void 0);
      cloned.requestMapper = requestMapper;
      return cloned;
    };
    this.setResponseMapper = (responseMapper) => {
      const cloned = this.clone();
      cloned.responseMapper = responseMapper;
      return cloned;
    };
    this.paramsMapper = (params, queryParams) => {
      let endpoint = this.requestOptions.endpoint;
      if (params) {
        Object.entries(params).forEach(([key, value]) => {
          endpoint = endpoint.replace(new RegExp(`:${key}`, "g"), String(value));
        });
      }
      if (queryParams) {
        endpoint += this.client.stringifyQueryParams(queryParams);
      }
      return endpoint;
    };
    this.abort = () => {
      const { requestManager } = this.client;
      requestManager.abortByKey(this.abortKey);
      return this.clone();
    };
    this.exec = (options) => __async(this, null, function* () {
      const { adapter: adapter3, requestManager } = this.client;
      const request = this.clone(options);
      const requestId = getUniqueRequestId(this.queueKey);
      requestManager.addAbortController(this.abortKey, requestId);
      const response = yield adapter3(request, requestId);
      requestManager.removeAbortController(this.abortKey, requestId);
      if (request.responseMapper) {
        return request.responseMapper(response);
      }
      return response;
    });
    this.send = (options) => __async(this, null, function* () {
      const _a = options || {}, { dispatcherType } = _a, rest = __objRest(_a, ["dispatcherType"]);
      const request = this.clone(rest);
      return sendRequest(request, options);
    });
    var _a, _b, _c, _d, _e, _f, _g, _h, _i, _j, _k, _l, _m, _n, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _A, _B, _C;
    const {
      endpoint,
      headers,
      auth = true,
      method = client.defaultMethod,
      options,
      cancelable = false,
      retry = 0,
      retryTime = 500,
      garbageCollection = 6e4 /* minute */ * 5,
      cache = true,
      cacheTime = 6e4 /* minute */ * 5,
      queued = false,
      offline = true,
      abortKey,
      cacheKey,
      queueKey,
      effectKey,
      deduplicate = false,
      deduplicateTime = 10
    } = __spreadValues(__spreadValues({}, (_b = (_a = this.client).requestDefaultOptions) == null ? void 0 : _b.call(_a, requestOptions)), requestOptions);
    this.endpoint = (_c = requestJSON == null ? void 0 : requestJSON.endpoint) != null ? _c : endpoint;
    this.headers = (_d = requestJSON == null ? void 0 : requestJSON.headers) != null ? _d : headers;
    this.auth = (_e = requestJSON == null ? void 0 : requestJSON.auth) != null ? _e : auth;
    this.method = method;
    this.params = requestJSON == null ? void 0 : requestJSON.params;
    this.data = requestJSON == null ? void 0 : requestJSON.data;
    this.queryParams = requestJSON == null ? void 0 : requestJSON.queryParams;
    this.options = (_f = requestJSON == null ? void 0 : requestJSON.options) != null ? _f : options;
    this.cancelable = (_g = requestJSON == null ? void 0 : requestJSON.cancelable) != null ? _g : cancelable;
    this.retry = (_h = requestJSON == null ? void 0 : requestJSON.retry) != null ? _h : retry;
    this.retryTime = (_i = requestJSON == null ? void 0 : requestJSON.retryTime) != null ? _i : retryTime;
    this.garbageCollection = (_j = requestJSON == null ? void 0 : requestJSON.garbageCollection) != null ? _j : garbageCollection;
    this.cache = (_k = requestJSON == null ? void 0 : requestJSON.cache) != null ? _k : cache;
    this.cacheTime = (_l = requestJSON == null ? void 0 : requestJSON.cacheTime) != null ? _l : cacheTime;
    this.queued = (_m = requestJSON == null ? void 0 : requestJSON.queued) != null ? _m : queued;
    this.offline = (_n = requestJSON == null ? void 0 : requestJSON.offline) != null ? _n : offline;
    this.abortKey = (_p = (_o = requestJSON == null ? void 0 : requestJSON.abortKey) != null ? _o : abortKey) != null ? _p : this.client.abortKeyMapper(this);
    this.cacheKey = (_r = (_q = requestJSON == null ? void 0 : requestJSON.cacheKey) != null ? _q : cacheKey) != null ? _r : this.client.cacheKeyMapper(this);
    this.queueKey = (_t = (_s = requestJSON == null ? void 0 : requestJSON.queueKey) != null ? _s : queueKey) != null ? _t : this.client.queueKeyMapper(this);
    this.effectKey = (_v = (_u = requestJSON == null ? void 0 : requestJSON.effectKey) != null ? _u : effectKey) != null ? _v : this.client.effectKeyMapper(this);
    this.used = (_w = requestJSON == null ? void 0 : requestJSON.used) != null ? _w : false;
    this.deduplicate = (_x = requestJSON == null ? void 0 : requestJSON.deduplicate) != null ? _x : deduplicate;
    this.deduplicateTime = (_y = requestJSON == null ? void 0 : requestJSON.deduplicateTime) != null ? _y : deduplicateTime;
    this.updatedAbortKey = (_z = requestJSON == null ? void 0 : requestJSON.updatedAbortKey) != null ? _z : false;
    this.updatedCacheKey = (_A = requestJSON == null ? void 0 : requestJSON.updatedCacheKey) != null ? _A : false;
    this.updatedQueueKey = (_B = requestJSON == null ? void 0 : requestJSON.updatedQueueKey) != null ? _B : false;
    this.updatedEffectKey = (_C = requestJSON == null ? void 0 : requestJSON.updatedEffectKey) != null ? _C : false;
  }
  toJSON() {
    return {
      requestOptions: this.requestOptions,
      endpoint: this.endpoint,
      headers: this.headers,
      auth: this.auth,
      method: this.method,
      params: this.params,
      data: this.data,
      queryParams: this.queryParams,
      options: this.options,
      cancelable: this.cancelable,
      retry: this.retry,
      retryTime: this.retryTime,
      garbageCollection: this.garbageCollection,
      cache: this.cache,
      cacheTime: this.cacheTime,
      queued: this.queued,
      offline: this.offline,
      abortKey: this.abortKey,
      cacheKey: this.cacheKey,
      queueKey: this.queueKey,
      effectKey: this.effectKey,
      used: this.used,
      disableResponseInterceptors: this.requestOptions.disableResponseInterceptors,
      disableRequestInterceptors: this.requestOptions.disableRequestInterceptors,
      updatedAbortKey: this.updatedAbortKey,
      updatedCacheKey: this.updatedCacheKey,
      updatedQueueKey: this.updatedQueueKey,
      updatedEffectKey: this.updatedEffectKey,
      deduplicate: this.deduplicate,
      deduplicateTime: this.deduplicateTime
    };
  }
  clone(options) {
    const json = this.toJSON();
    const requestJSON = __spreadProps(__spreadValues(__spreadValues({}, json), options), {
      abortKey: this.updatedAbortKey ? (options == null ? void 0 : options.abortKey) || this.abortKey : void 0,
      cacheKey: this.updatedCacheKey ? (options == null ? void 0 : options.cacheKey) || this.cacheKey : void 0,
      queueKey: this.updatedQueueKey ? (options == null ? void 0 : options.queueKey) || this.queueKey : void 0,
      endpoint: this.paramsMapper((options == null ? void 0 : options.params) || this.params, (options == null ? void 0 : options.queryParams) || this.queryParams),
      queryParams: (options == null ? void 0 : options.queryParams) || this.queryParams,
      data: (options == null ? void 0 : options.data) || this.data
    });
    const cloned = new Request(
      this.client,
      this.requestOptions,
      requestJSON
    );
    cloned.dataMapper = this.dataMapper;
    cloned.responseMapper = this.responseMapper;
    cloned.requestMapper = this.requestMapper;
    cloned.mockData = this.mockData;
    cloned.mock = this.mock;
    cloned.isMockEnabled = this.isMockEnabled;
    return cloned;
  }
};

// src/constants/http.constants.ts
var HttpMethodsEnum = /* @__PURE__ */ ((HttpMethodsEnum2) => {
  HttpMethodsEnum2["get"] = "GET";
  HttpMethodsEnum2["post"] = "POST";
  HttpMethodsEnum2["put"] = "PUT";
  HttpMethodsEnum2["patch"] = "PATCH";
  HttpMethodsEnum2["delete"] = "DELETE";
  return HttpMethodsEnum2;
})(HttpMethodsEnum || {});

// src/dispatcher/dispatcher.constants.ts
var DispatcherRequestType = /* @__PURE__ */ ((DispatcherRequestType2) => {
  DispatcherRequestType2["oneByOne"] = "one-by-one";
  DispatcherRequestType2["allAtOnce"] = "all-at-once";
  DispatcherRequestType2["previousCanceled"] = "previous-canceled";
  DispatcherRequestType2["deduplicated"] = "deduplicated";
  return DispatcherRequestType2;
})(DispatcherRequestType || {});

// src/dispatcher/dispatcher.events.ts
var getDispatcherEvents = (emitter) => ({
  setDrained: (queueKey, values) => {
    emitter.emit(getDispatcherDrainedEventKey(queueKey), values);
  },
  setQueueStatus: (queueKey, values) => {
    emitter.emit(getDispatcherStatusEventKey(queueKey), values);
  },
  setQueueChanged: (queueKey, values) => {
    emitter.emit(getDispatcherChangeEventKey(queueKey), values);
  },
  onDrained: (queueKey, callback) => {
    emitter.on(getDispatcherDrainedEventKey(queueKey), callback);
    return () => emitter.removeListener(getDispatcherDrainedEventKey(queueKey), callback);
  },
  onQueueStatus: (queueKey, callback) => {
    emitter.on(getDispatcherStatusEventKey(queueKey), callback);
    return () => emitter.removeListener(getDispatcherStatusEventKey(queueKey), callback);
  },
  onQueueChange: (queueKey, callback) => {
    emitter.on(getDispatcherChangeEventKey(queueKey), callback);
    return () => emitter.removeListener(getDispatcherChangeEventKey(queueKey), callback);
  }
});

// src/dispatcher/dispatcher.ts
import EventEmitter from "events";
var Dispatcher = class {
  constructor(client, options) {
    this.client = client;
    this.options = options;
    this.emitter = new EventEmitter();
    this.events = getDispatcherEvents(this.emitter);
    this.storage = /* @__PURE__ */ new Map();
    this.requestCount = /* @__PURE__ */ new Map();
    this.runningRequests = /* @__PURE__ */ new Map();
    this.start = (queueKey) => {
      const queue = this.getQueue(queueKey);
      queue.stopped = false;
      this.setQueue(queueKey, queue);
      this.flushQueue(queueKey);
      this.events.setQueueStatus(queueKey, queue);
    };
    this.pause = (queueKey) => {
      const queue = this.getQueue(queueKey);
      queue.stopped = true;
      this.setQueue(queueKey, queue);
      this.events.setQueueStatus(queueKey, queue);
    };
    this.stop = (queueKey) => {
      const queue = this.getQueue(queueKey);
      queue.stopped = true;
      this.setQueue(queueKey, queue);
      this.cancelRunningRequests(queueKey);
      this.events.setQueueStatus(queueKey, queue);
    };
    this.getQueuesKeys = () => {
      return Array.from(this.storage.keys());
    };
    this.getQueue = (queueKey) => {
      const initialQueueState = { requests: [], stopped: false };
      const storedEntity = this.storage.get(queueKey);
      return storedEntity || initialQueueState;
    };
    this.getRequest = (queueKey, requestId) => {
      const initialQueueState = { requests: [], stopped: false };
      const storedEntity = this.storage.get(queueKey) || initialQueueState;
      return storedEntity.requests.find((req) => req.requestId === requestId);
    };
    this.getIsActiveQueue = (queueKey) => {
      const queue = this.getQueue(queueKey);
      const hasAvailableRequests = queue.requests.some((req) => !req.stopped);
      const isRunningQueue = !queue.stopped;
      return hasAvailableRequests && isRunningQueue;
    };
    this.addQueueElement = (queueKey, dispatcherDump) => {
      const queue = this.getQueue(queueKey);
      queue.requests.push(dispatcherDump);
      this.setQueue(queueKey, queue);
    };
    this.setQueue = (queueKey, queue) => {
      var _a, _b;
      this.storage.set(queueKey, queue);
      (_b = (_a = this.options) == null ? void 0 : _a.onUpdateStorage) == null ? void 0 : _b.call(_a, queueKey, queue);
      this.events.setQueueChanged(queueKey, queue);
      return queue;
    };
    this.clearQueue = (queueKey) => {
      var _a, _b;
      const queue = this.getQueue(queueKey);
      const newQueue = { requests: [], stopped: queue.stopped };
      this.storage.set(queueKey, newQueue);
      (_b = (_a = this.options) == null ? void 0 : _a.onDeleteFromStorage) == null ? void 0 : _b.call(_a, queueKey, newQueue);
      this.events.setQueueChanged(queueKey, newQueue);
      return newQueue;
    };
    this.flushQueue = (queueKey) => __async(this, null, function* () {
      const queue = this.getQueue(queueKey);
      const runningRequests = this.getRunningRequests(queueKey);
      const queueElement = queue.requests.find((request) => !request.stopped);
      const isStopped = queue && queue.stopped;
      const isOffline = !this.client.appManager.isOnline;
      const isConcurrent = !(queueElement == null ? void 0 : queueElement.request.queued);
      const isInactive = !runningRequests.length;
      const isEmpty = !queueElement;
      if (isStopped || isOffline || isEmpty) {
        this.logger.debug("Skipping queue trigger", { isStopped, isOffline, isEmpty });
      } else if (isConcurrent) {
        queue.requests.forEach((element) => {
          if (!this.hasRunningRequest(queueKey, element.requestId)) {
            this.performRequest(element);
          }
        });
      } else if (isInactive) {
        yield this.performRequest(queueElement);
        this.flushQueue(queueKey);
      }
    });
    this.flush = () => __async(this, null, function* () {
      const keys = this.getQueuesKeys();
      for (const key of keys) {
        const storageElement = this.getQueue(key);
        if (storageElement) {
          this.flushQueue(key);
        }
      }
    });
    this.clear = () => {
      var _a, _b;
      const keys = this.getQueuesKeys();
      keys.forEach((queueKey) => this.cancelRunningRequests(queueKey));
      this.runningRequests.clear();
      this.storage.clear();
      (_b = (_a = this.options) == null ? void 0 : _a.onClearStorage) == null ? void 0 : _b.call(_a, this);
    };
    this.startRequest = (queueKey, requestId) => {
      const queue = this.getQueue(queueKey);
      const request = queue.requests.find((element) => element.requestId === requestId);
      if (request) {
        request.stopped = false;
        this.setQueue(queueKey, queue);
        this.flushQueue(queueKey);
        this.events.setQueueStatus(queueKey, queue);
      }
    };
    this.stopRequest = (queueKey, requestId) => {
      const queue = this.getQueue(queueKey);
      const request = queue.requests.find((element) => element.requestId === requestId);
      if (request) {
        request.stopped = true;
        this.setQueue(queueKey, queue);
        this.cancelRunningRequest(queueKey, requestId);
        this.events.setQueueStatus(queueKey, queue);
      }
    };
    this.getAllRunningRequest = () => {
      return Array.from(this.runningRequests.values()).flat();
    };
    this.getRunningRequests = (queueKey) => {
      return this.runningRequests.get(queueKey) || [];
    };
    this.getRunningRequest = (queueKey, requestId) => {
      const runningRequests = this.getRunningRequests(queueKey);
      return runningRequests.find((req) => req.requestId === requestId);
    };
    this.addRunningRequest = (queueKey, requestId, request) => {
      const runningRequests = this.getRunningRequests(queueKey);
      runningRequests.push({ requestId, request, timestamp: Date.now() });
      this.runningRequests.set(queueKey, runningRequests);
    };
    this.hasRunningRequests = (queueKey) => {
      return !!this.getRunningRequests(queueKey).length;
    };
    this.hasRunningRequest = (queueKey, requestId) => {
      const runningRequests = this.getRunningRequests(queueKey);
      return !!runningRequests.find((req) => req.requestId === requestId);
    };
    this.cancelRunningRequests = (queueKey) => {
      var _a;
      (_a = this.runningRequests.get(queueKey)) == null ? void 0 : _a.forEach((request) => {
        this.client.requestManager.abortByRequestId(request.request.abortKey, request.requestId);
      });
      this.deleteRunningRequests(queueKey);
    };
    this.cancelRunningRequest = (queueKey, requestId) => {
      const requests = this.getRunningRequests(queueKey).filter((request) => {
        if (request.requestId === requestId) {
          this.client.requestManager.abortByRequestId(request.request.abortKey, request.requestId);
          return false;
        }
        return true;
      });
      this.runningRequests.set(queueKey, requests);
    };
    this.deleteRunningRequests = (queueKey) => {
      this.runningRequests.set(queueKey, []);
    };
    this.deleteRunningRequest = (queueKey, requestId) => {
      const runningRequests = this.getRunningRequests(queueKey);
      this.runningRequests.set(
        queueKey,
        runningRequests.filter((req) => req.requestId !== requestId)
      );
    };
    this.getQueueRequestCount = (queueKey) => {
      return this.requestCount.get(queueKey) || 0;
    };
    this.incrementQueueRequestCount = (queueKey) => {
      const count = this.requestCount.get(queueKey) || 0;
      this.requestCount.set(queueKey, count + 1);
    };
    this.createStorageElement = (request) => {
      const requestId = getUniqueRequestId(request.queueKey);
      const storageElement = {
        requestId,
        timestamp: +new Date(),
        request,
        retries: 0,
        stopped: false
      };
      return storageElement;
    };
    this.add = (request) => {
      const { queueKey } = request;
      const storageElement = this.createStorageElement(request);
      const { requestId } = storageElement;
      const queue = this.getQueue(queueKey);
      const [latestRequest] = queue.requests.slice(-1);
      const requestType = getRequestType(request, latestRequest);
      this.logger.debug("Adding request to queue", { requestType, request, requestId });
      switch (requestType) {
        case "one-by-one" /* oneByOne */: {
          this.addQueueElement(queueKey, storageElement);
          this.flushQueue(queueKey);
          return requestId;
        }
        case "previous-canceled" /* previousCanceled */: {
          this.cancelRunningRequests(queueKey);
          this.clearQueue(queueKey);
          this.addQueueElement(queueKey, storageElement);
          this.flushQueue(queueKey);
          return requestId;
        }
        case "deduplicated" /* deduplicated */: {
          return queue.requests[0].requestId;
        }
        default: {
          this.addQueueElement(queueKey, storageElement);
          this.flushQueue(queueKey);
          return requestId;
        }
      }
    };
    this.delete = (queueKey, requestId, abortKey) => {
      var _a, _b;
      this.logger.debug("Deleting request", { queueKey, requestId, abortKey });
      const queue = this.getQueue(queueKey);
      const queueElement = queue.requests.find((req) => req.requestId === requestId);
      if (!queueElement)
        return;
      queue.requests = queue.requests.filter((req) => req.requestId !== requestId);
      this.storage.set(queueKey, queue);
      if (this.hasRunningRequest(queueKey, requestId)) {
        this.deleteRunningRequest(queueKey, requestId);
        this.client.requestManager.abortByRequestId(abortKey, requestId);
      }
      (_b = (_a = this.options) == null ? void 0 : _a.onDeleteFromStorage) == null ? void 0 : _b.call(_a, queueKey, queue);
      this.events.setQueueChanged(queueKey, queue);
      this.client.requestManager.events.emitRemove(queueKey, requestId, { requestId, request: queueElement.request });
      if (!queue.requests.length) {
        this.events.setDrained(queueKey, queue);
      }
      return queue;
    };
    this.performRequest = (storageElement) => __async(this, null, function* () {
      var _a;
      const { request, requestId } = storageElement;
      this.logger.info("Performing request", { request, requestId });
      const { retry, retryTime, queueKey, cacheKey, abortKey, offline } = request;
      const { adapter: adapter3, requestManager, cache, appManager } = this.client;
      const canRetry = canRetryRequest(storageElement.retries, retry);
      const isOffline = !appManager.isOnline && offline;
      const isAlreadyRunning = this.hasRunningRequest(queueKey, requestId);
      const isStopped = storageElement.stopped;
      if (isOffline || isAlreadyRunning || isStopped) {
        return this.logger.warning("Unable to perform request", { isOffline, isAlreadyRunning, isStopped });
      }
      this.addRunningRequest(queueKey, requestId, request);
      requestManager.events.emitLoading(queueKey, requestId, {
        queueKey,
        requestId,
        loading: true,
        isRetry: !!storageElement.retries,
        isOffline
      });
      this.incrementQueueRequestCount(queueKey);
      requestManager.addAbortController(abortKey, requestId);
      const response = yield adapter3(request, requestId);
      requestManager.removeAbortController(abortKey, requestId);
      const isOfflineResponseStatus = !appManager.isOnline;
      const isCancelMessage = getErrorMessage("abort").message === ((_a = response.error) == null ? void 0 : _a.message);
      const isCanceled = !this.hasRunningRequest(queueKey, requestId) || isCancelMessage;
      this.deleteRunningRequest(queueKey, requestId);
      const requestDetails = {
        isCanceled,
        isOffline: isOfflineResponseStatus,
        retries: storageElement.retries,
        timestamp: +new Date()
      };
      requestManager.events.emitResponse(cacheKey, requestId, response, requestDetails);
      requestManager.events.emitLoading(queueKey, requestId, {
        queueKey,
        requestId,
        loading: false,
        isRetry: !!storageElement.retries,
        isOffline
      });
      cache.set(request, __spreadValues(__spreadValues({}, response), requestDetails));
      this.logger.info("Request finished", { requestId, request, response, requestDetails });
      if (isCanceled) {
        const queue = this.getQueue(queueKey);
        const queueElement = queue.requests.find((req) => req.requestId === requestId);
        if (!queue.stopped && !(queueElement == null ? void 0 : queueElement.stopped)) {
          this.logger.debug("Request paused", { response, requestDetails, request });
          return this.delete(queueKey, requestId, abortKey);
        }
        return this.logger.debug("Request canceled", { response, requestDetails, request });
      }
      if (!response.success && isOfflineResponseStatus) {
        if (!offline) {
          this.logger.warning("Removing non-offline request", { response, requestDetails, request });
          return this.delete(queueKey, requestId, abortKey);
        }
        return this.logger.debug("Awaiting for network restoration", { response, requestDetails, request });
      }
      if (response.success) {
        this.delete(queueKey, requestId, abortKey);
        return this.logger.debug("Successful response, removing request from queue.", {
          response,
          requestDetails,
          request
        });
      }
      if (!response.success && canRetry) {
        this.logger.debug("Waiting for retry", { response, requestDetails, request });
        setTimeout(() => {
          this.logger.warning("Error response, performing retry");
          this.performRequest(__spreadProps(__spreadValues({}, storageElement), {
            retries: storageElement.retries + 1
          }));
        }, retryTime || 0);
      } else {
        this.logger.error("All retries have been used. Removing request from queue.");
        this.delete(queueKey, requestId, abortKey);
      }
    });
    var _a, _b, _c;
    this.logger = client.loggerManager.init("Dispatcher");
    if ((_a = this.options) == null ? void 0 : _a.storage) {
      this.storage = this.options.storage;
    }
    this.client.appManager.events.onOnline(() => {
      this.flush();
    });
    (_c = (_b = this.options) == null ? void 0 : _b.onInitialization) == null ? void 0 : _c.call(_b, this);
  }
};

// src/dispatcher/dispatcher.utils.ts
var getDispatcherDrainedEventKey = (key) => {
  return `${key}-drained-event`;
};
var getDispatcherStatusEventKey = (key) => {
  return `${key}-status-event`;
};
var getDispatcherChangeEventKey = (key) => {
  return `${key}-change-event`;
};
var getIsEqualTimestamp = (currentTimestamp, threshold, queueTimestamp) => {
  if (!queueTimestamp) {
    return false;
  }
  return queueTimestamp - currentTimestamp <= threshold;
};
var canRetryRequest = (currentRetries, retry) => {
  if (retry && currentRetries < retry) {
    return true;
  }
  return false;
};
var getRequestType = (request, latestRequest) => {
  const { queued, cancelable, deduplicate } = request;
  const canDeduplicate = latestRequest ? +new Date() - latestRequest.timestamp <= request.deduplicateTime : false;
  if (queued) {
    return "one-by-one" /* oneByOne */;
  }
  if (cancelable) {
    return "previous-canceled" /* previousCanceled */;
  }
  if (canDeduplicate && deduplicate) {
    return "deduplicated" /* deduplicated */;
  }
  return "all-at-once" /* allAtOnce */;
};

// src/request/request.utils.ts
var stringifyKey = (value) => {
  try {
    if (typeof value === "string")
      return value;
    if (value === void 0 || value === null)
      return "";
    const data = JSON.stringify(value);
    if (typeof data !== "string")
      throw new Error();
    return data;
  } catch (_) {
    return "";
  }
};
var getProgressValue = ({ loaded, total }) => {
  if (!loaded || !total)
    return 0;
  return Number((loaded * 100 / total).toFixed(0));
};
var getRequestEta = (startDate, progressDate, { total, loaded }) => {
  const timeElapsed = +progressDate - +startDate || 1;
  const uploadSpeed = loaded / timeElapsed;
  const totalValue = Math.max(total, loaded);
  const sizeLeft = totalValue - loaded;
  const estimatedTimeValue = uploadSpeed ? sizeLeft / uploadSpeed : null;
  const timeLeft = totalValue === loaded ? 0 : estimatedTimeValue;
  return { timeLeft, sizeLeft };
};
var getProgressData = (requestStartTime, progressDate, progressEvent) => {
  const { total, loaded } = progressEvent;
  if (Number.isNaN(total) || Number.isNaN(loaded)) {
    return {
      progress: 0,
      timeLeft: 0,
      sizeLeft: 0,
      total: 0,
      loaded: 0,
      startTimestamp: +requestStartTime
    };
  }
  const { timeLeft, sizeLeft } = getRequestEta(requestStartTime, progressDate, progressEvent);
  return {
    progress: getProgressValue(progressEvent),
    timeLeft,
    sizeLeft,
    total,
    loaded,
    startTimestamp: +requestStartTime
  };
};
var getSimpleKey = (request) => {
  return `${request.method}_${request.requestOptions.endpoint}_${request.cancelable}`;
};
var getRequestKey = (request, useInitialValues) => {
  const methodKey = stringifyKey(request.method);
  const endpointKey = useInitialValues ? request.requestOptions.endpoint : stringifyKey(request.endpoint);
  return `${methodKey}_${endpointKey}`;
};
var getRequestDispatcher = (request, dispatcherType = "auto") => {
  const { fetchDispatcher, submitDispatcher } = request.client;
  const isGet = request.method === "GET" /* get */;
  const isFetchDispatcher = dispatcherType === "auto" && isGet || dispatcherType === "fetch";
  const dispatcher = isFetchDispatcher ? fetchDispatcher : submitDispatcher;
  return [dispatcher, isFetchDispatcher];
};
var sendRequest = (request, options) => {
  const { requestManager } = request.client;
  const [dispatcher] = getRequestDispatcher(request, options == null ? void 0 : options.dispatcherType);
  return new Promise((resolve) => {
    var _a;
    let isResolved = false;
    const requestId = dispatcher.add(request);
    (_a = options == null ? void 0 : options.onSettle) == null ? void 0 : _a.call(options, requestId, request);
    const unmountRequestStart = requestManager.events.onRequestStartById(
      requestId,
      (...props) => {
        var _a2;
        return (_a2 = options == null ? void 0 : options.onRequestStart) == null ? void 0 : _a2.call(options, ...props);
      }
    );
    const unmountResponseStart = requestManager.events.onResponseStartById(
      requestId,
      (...props) => {
        var _a2;
        return (_a2 = options == null ? void 0 : options.onResponseStart) == null ? void 0 : _a2.call(options, ...props);
      }
    );
    const unmountUpload = requestManager.events.onUploadProgressById(
      requestId,
      (...props) => {
        var _a2;
        return (_a2 = options == null ? void 0 : options.onUploadProgress) == null ? void 0 : _a2.call(options, ...props);
      }
    );
    const unmountDownload = requestManager.events.onDownloadProgressById(
      requestId,
      (...props) => {
        var _a2;
        return (_a2 = options == null ? void 0 : options.onDownloadProgress) == null ? void 0 : _a2.call(options, ...props);
      }
    );
    const unmountResponse = requestManager.events.onResponseById(requestId, (response, details) => {
      var _a2;
      isResolved = true;
      const mapping = (_a2 = request.responseMapper) == null ? void 0 : _a2.call(request, response);
      const isOfflineStatus = request.offline && details.isOffline;
      const willRetry = canRetryRequest(details.retries, request.retry);
      const handleResponse = (success, data) => {
        var _a3;
        if (!success && isOfflineStatus)
          return;
        if (!success && willRetry)
          return;
        (_a3 = options == null ? void 0 : options.onResponse) == null ? void 0 : _a3.call(options, data, details);
        resolve(data);
        umountAll();
      };
      if (mapping instanceof Promise) {
        (() => __async(void 0, null, function* () {
          const responseData = yield mapping;
          const { success } = responseData;
          handleResponse(success, responseData);
        }))();
      } else {
        const data = mapping || response;
        const { success } = data;
        handleResponse(success, data);
      }
    });
    const unmountRemoveQueueElement = requestManager.events.onRemoveById(requestId, (...props) => {
      var _a2;
      if (!isResolved) {
        (_a2 = options == null ? void 0 : options.onRemove) == null ? void 0 : _a2.call(options, ...props);
        resolve({
          data: null,
          status: null,
          success: null,
          error: getErrorMessage("deleted"),
          extra: request.client.defaultExtra
        });
        umountAll();
      }
    });
    function umountAll() {
      unmountRequestStart();
      unmountResponseStart();
      unmountUpload();
      unmountDownload();
      unmountResponse();
      unmountRemoveQueueElement();
    }
  });
};

// src/mocker/mocker.ts
var mocker = (_0, _1) => __async(void 0, [_0, _1], function* (request, {
  onError,
  onResponseEnd,
  onTimeoutError,
  onRequestEnd,
  createAbortListener,
  onResponseProgress,
  onRequestProgress,
  onResponseStart,
  onBeforeRequest,
  onRequestStart,
  onSuccess
}) {
  const mock = request.mock.next();
  const result = mock.value instanceof Function ? yield mock.value(request) : mock.value;
  return new Promise((resolve) => {
    const { data, status = 200, success = true, extra, config } = result;
    const {
      requestTime = 20,
      responseTime = 20,
      totalUploaded = 1,
      totalDownloaded = 1,
      timeout = false
    } = config || {};
    createAbortListener(0, {}, () => {
    }, resolve);
    onBeforeRequest();
    onRequestStart();
    const progress = (totalTime, totalSize, progressFunction) => new Promise((resolveProgress) => {
      const interval = 20;
      const dataStart = +new Date();
      const chunkSize = Math.floor(totalSize / Math.floor(totalTime / Math.min(totalTime, interval)));
      let currentlyLoaded = 0;
      const timer = setInterval(function handleProgressInterval() {
        const currentTime = Math.min(totalTime, +new Date() - dataStart);
        currentlyLoaded += currentlyLoaded + chunkSize >= totalSize ? totalSize - currentlyLoaded : chunkSize;
        if (currentTime >= totalTime) {
          resolveProgress(true);
          clearInterval(timer);
        } else {
          progressFunction({
            total: totalSize,
            loaded: currentlyLoaded
          });
        }
      }, interval);
    });
    const getResponse = () => __async(void 0, null, function* () {
      yield progress(requestTime, totalUploaded, onRequestProgress);
      onRequestEnd();
      onResponseStart();
      yield progress(responseTime, totalDownloaded, onResponseProgress);
      if (success) {
        onSuccess(data, status, extra || {}, resolve);
      } else {
        onError(data, status, extra || {}, resolve);
      }
    });
    if (timeout) {
      setTimeout(() => onTimeoutError(0, extra || {}, resolve), 1);
    } else {
      setTimeout(getResponse, requestTime + responseTime + 1);
    }
    onResponseEnd();
  });
});

// src/adapter/adapter.bindings.ts
var getAdapterBindings = (req, requestId, systemErrorStatus, systemErrorExtra) => __async(void 0, null, function* () {
  const { url, requestManager, loggerManager, headerMapper, payloadMapper } = req.client;
  const logger2 = loggerManager.init("Adapter");
  let processingError = null;
  let requestStartTimestamp = null;
  let responseStartTimestamp = null;
  let request = req;
  let requestTotal = 1;
  let responseTotal = 1;
  let previousRequestTotal = 0;
  let previousResponseTotal = 0;
  logger2.debug(`Starting request middleware callbacks`);
  try {
    request = yield request.client.__modifyRequest(req);
    if (request.auth) {
      request = yield request.client.__modifyAuth(req);
    }
    if (request.requestMapper) {
      request = yield request.requestMapper(request, requestId);
    }
  } catch (err) {
    processingError = err;
  }
  const { client, abortKey, queueKey, endpoint, data } = request;
  const fullUrl = url + endpoint;
  const effects = client.effects.filter((effect) => request.effectKey === effect.getEffectKey());
  const headers = headerMapper(request);
  let payload = data;
  try {
    payload = payloadMapper(data);
    if (request.dataMapper) {
      payload = yield request.dataMapper(data);
    }
  } catch (err) {
    processingError = err;
  }
  const config = __spreadValues({}, request.options);
  const getRequestStartTimestamp = () => {
    return requestStartTimestamp;
  };
  const getResponseStartTimestamp = () => {
    return responseStartTimestamp;
  };
  const getTotal = (previousTotal, progress) => {
    if (!progress)
      return previousTotal;
    const total = Number(progress.total || 0);
    const loaded = Number(progress.loaded || 0);
    return Math.max(total, loaded, previousTotal);
  };
  const handleRequestProgress = (startTimestamp, progressTimestamp, progressEvent) => {
    const progress = getProgressData(new Date(startTimestamp), new Date(progressTimestamp), progressEvent);
    if (previousRequestTotal !== 100) {
      previousRequestTotal = progress.total;
      requestManager.events.emitUploadProgress(queueKey, requestId, progress, { requestId, request });
    }
  };
  const handleResponseProgress = (startTimestamp, progressTimestamp, progressEvent) => {
    const progress = getProgressData(new Date(startTimestamp), new Date(progressTimestamp), progressEvent);
    if (previousResponseTotal !== 100) {
      previousResponseTotal = progress.total;
      requestManager.events.emitDownloadProgress(queueKey, requestId, progress, { requestId, request });
    }
  };
  const onBeforeRequest = () => {
    effects.forEach((effect) => effect.onTrigger(request));
  };
  const onRequestStart = (progress) => {
    effects.forEach((action) => action.onStart(request));
    if (progress == null ? void 0 : progress.total) {
      requestTotal = getTotal(requestTotal, progress);
    }
    const initialPayload = {
      total: requestTotal,
      loaded: (progress == null ? void 0 : progress.loaded) || 0
    };
    requestStartTimestamp = +new Date();
    handleRequestProgress(requestStartTimestamp, requestStartTimestamp, initialPayload);
    requestManager.events.emitRequestStart(queueKey, requestId, { requestId, request });
    return requestStartTimestamp;
  };
  const onRequestProgress = (progress) => {
    if (!requestStartTimestamp) {
      requestStartTimestamp = +new Date();
    }
    requestTotal = getTotal(requestTotal, progress);
    const progressTimestamp = +new Date();
    handleRequestProgress(requestStartTimestamp, progressTimestamp, {
      total: requestTotal,
      loaded: progress.loaded || 0
    });
    return progressTimestamp;
  };
  const onRequestEnd = () => {
    if (!requestStartTimestamp) {
      requestStartTimestamp = +new Date();
    }
    const progressTimestamp = +new Date();
    handleRequestProgress(requestStartTimestamp, progressTimestamp, {
      total: requestTotal,
      loaded: requestTotal
    });
    return progressTimestamp;
  };
  const onResponseStart = (progress) => {
    responseStartTimestamp = +new Date();
    responseTotal = getTotal(responseTotal, progress);
    const initialPayload = {
      total: responseTotal,
      loaded: (progress == null ? void 0 : progress.loaded) || 0
    };
    handleResponseProgress(responseStartTimestamp, responseStartTimestamp, initialPayload);
    requestManager.events.emitResponseStart(queueKey, requestId, { requestId, request });
    return responseStartTimestamp;
  };
  const onResponseProgress = (progress) => {
    if (!responseStartTimestamp) {
      responseStartTimestamp = +new Date();
    }
    const progressTimestamp = +new Date();
    responseTotal = getTotal(responseTotal, progress);
    handleResponseProgress(responseStartTimestamp, progressTimestamp, {
      total: progress.total || responseTotal,
      loaded: progress.loaded || 0
    });
    return progressTimestamp;
  };
  const onResponseEnd = () => {
    if (!responseStartTimestamp) {
      responseStartTimestamp = +new Date();
    }
    const progressTimestamp = +new Date();
    handleResponseProgress(responseStartTimestamp, progressTimestamp, {
      total: responseTotal,
      loaded: responseTotal
    });
    return progressTimestamp;
  };
  const onSuccess = (responseData, status, extra, resolve) => __async(void 0, null, function* () {
    let response = {
      data: responseData,
      error: null,
      success: true,
      status,
      extra
    };
    response = yield request.client.__modifyResponse(response, request);
    response = yield request.client.__modifySuccessResponse(response, request);
    effects.forEach((effect) => effect.onSuccess(response, request));
    effects.forEach((effect) => effect.onFinished(response, request));
    resolve(response);
    return response;
  });
  const onError = (error, status, extra, resolve) => __async(void 0, null, function* () {
    let responseData = {
      data: null,
      status,
      error,
      success: false,
      extra
    };
    responseData = yield request.client.__modifyResponse(responseData, request);
    responseData = yield request.client.__modifyErrorResponse(responseData, request);
    effects.forEach((effect) => effect.onError(responseData, request));
    effects.forEach((effect) => effect.onFinished(responseData, request));
    resolve(responseData);
    return responseData;
  });
  const onAbortError = (status, extra, resolve) => {
    const error = getErrorMessage("abort");
    return onError(error, status, extra, resolve);
  };
  const onTimeoutError = (status, extra, resolve) => {
    const error = getErrorMessage("timeout");
    return onError(error, status, extra, resolve);
  };
  const onUnexpectedError = (status, extra, resolve) => {
    const error = getErrorMessage();
    return onError(error, status, extra, resolve);
  };
  const getAbortController = () => {
    return requestManager.getAbortController(abortKey, requestId);
  };
  const createAbortListener = (status, abortExtra, callback, resolve) => {
    const controller = getAbortController();
    if (!controller) {
      throw new Error("Controller is not found");
    }
    const fn = () => {
      onAbortError(status, abortExtra, resolve);
      callback();
      requestManager.events.emitAbort(abortKey, requestId, request);
    };
    if (controller.signal.aborted) {
      fn();
    }
    controller.signal.addEventListener("abort", fn);
    return () => controller.signal.removeEventListener("abort", fn);
  };
  const makeRequest = (apiCall) => {
    if (processingError) {
      return onError(processingError, systemErrorStatus, systemErrorExtra, () => null);
    }
    if (req.mock && req.isMockEnabled && req.client.isMockEnabled) {
      return mocker(request, {
        onError,
        onResponseEnd,
        onTimeoutError,
        onRequestEnd,
        createAbortListener,
        onResponseProgress,
        onRequestProgress,
        onResponseStart,
        onBeforeRequest,
        onRequestStart,
        onSuccess
      });
    }
    return new Promise(apiCall);
  };
  logger2.debug(`Finishing request bindings creation`, {
    fullUrl,
    data,
    headers,
    payload,
    config
  });
  return {
    fullUrl,
    data,
    headers,
    payload,
    config,
    getAbortController,
    getRequestStartTimestamp,
    getResponseStartTimestamp,
    createAbortListener,
    onBeforeRequest,
    onRequestStart,
    onRequestProgress,
    onRequestEnd,
    onResponseStart,
    onResponseProgress,
    onResponseEnd,
    onSuccess,
    onAbortError,
    onTimeoutError,
    onUnexpectedError,
    onError,
    makeRequest
  };
});

// src/cache/cache.ts
import EventEmitter2 from "events";
var Cache = class {
  constructor(client, options) {
    this.client = client;
    this.options = options;
    this.emitter = new EventEmitter2();
    this.garbageCollectors = /* @__PURE__ */ new Map();
    this.set = (request, response) => {
      var _a, _b, _c;
      this.logger.debug("Processing cache response", { request, response });
      const { cacheKey, cache, cacheTime, garbageCollection } = request;
      const cachedData = this.storage.get(cacheKey);
      const processedResponse = typeof response === "function" ? response(cachedData) : response;
      const data = getCacheData(cachedData, processedResponse);
      const newCacheData = __spreadProps(__spreadValues({}, data), { cacheTime, clearKey: this.clearKey, garbageCollection });
      this.events.emitCacheData(
        cacheKey,
        newCacheData
      );
      this.logger.debug("Emitting cache response", { request, data });
      if (!cache) {
        return this.logger.debug("Prevented saving response to cache", { request, data });
      }
      if (processedResponse.success) {
        this.logger.debug("Saving response to cache storage", { request, data });
        this.storage.set(cacheKey, newCacheData);
        (_a = this.lazyStorage) == null ? void 0 : _a.set(cacheKey, newCacheData);
        (_c = (_b = this.options) == null ? void 0 : _b.onChange) == null ? void 0 : _c.call(_b, cacheKey, newCacheData);
        this.scheduleGarbageCollector(cacheKey);
      }
    };
    this.update = (request, partialResponse) => {
      this.logger.debug("Processing cache update", { request, partialResponse });
      const { cacheKey } = request;
      const cachedData = this.storage.get(cacheKey);
      const processedResponse = typeof partialResponse === "function" ? partialResponse(cachedData) : partialResponse;
      if (cachedData) {
        this.set(request, __spreadValues(__spreadValues({}, cachedData), processedResponse));
      }
    };
    this.get = (cacheKey) => {
      this.getLazyResource(cacheKey);
      const cachedData = this.storage.get(cacheKey);
      return cachedData;
    };
    this.keys = () => {
      const values = this.storage.keys();
      return Array.from(values);
    };
    this.delete = (cacheKey) => {
      var _a, _b, _c;
      this.logger.debug("Deleting cache element", { cacheKey });
      this.storage.delete(cacheKey);
      (_b = (_a = this.options) == null ? void 0 : _a.onDelete) == null ? void 0 : _b.call(_a, cacheKey);
      (_c = this.lazyStorage) == null ? void 0 : _c.delete(cacheKey);
    };
    this.invalidate = (cacheKey) => __async(this, null, function* () {
      this.logger.debug("Revalidating cache element", { cacheKey });
      const keys = yield this.getLazyKeys();
      if (typeof cacheKey === "string") {
        this.events.emitInvalidation(cacheKey);
        this.delete(cacheKey);
      } else {
        for (const entityKey of keys) {
          if (cacheKey.test(entityKey)) {
            this.events.emitInvalidation(entityKey);
            this.delete(entityKey);
          }
        }
      }
    });
    this.getLazyResource = (cacheKey) => __async(this, null, function* () {
      var _a;
      const data = yield (_a = this.lazyStorage) == null ? void 0 : _a.get(cacheKey);
      const syncData = this.storage.get(cacheKey);
      const hasLazyData = this.lazyStorage && data;
      if (hasLazyData) {
        const now = +new Date();
        const isNewestData = syncData ? syncData.timestamp < data.timestamp : true;
        const isStaleData = data.cacheTime <= now - data.timestamp;
        const isValidLazyData = data.clearKey === this.clearKey;
        if (!isValidLazyData) {
          this.lazyStorage.delete(cacheKey);
        }
        if (isNewestData && !isStaleData && isValidLazyData) {
          this.storage.set(cacheKey, data);
          this.events.emitCacheData(cacheKey, data);
          return data;
        }
      }
      const isValidData = (syncData == null ? void 0 : syncData.clearKey) === this.clearKey;
      if (syncData && !isValidData) {
        this.delete(cacheKey);
      }
      return syncData;
    });
    this.getLazyKeys = () => __async(this, null, function* () {
      var _a;
      const keys = yield (_a = this.lazyStorage) == null ? void 0 : _a.keys();
      const asyncKeys = Array.from(keys || []);
      const syncKeys = Array.from(this.storage.keys());
      return [.../* @__PURE__ */ new Set([...asyncKeys, ...syncKeys])];
    });
    this.scheduleGarbageCollector = (cacheKey) => __async(this, null, function* () {
      const cacheData = yield this.getLazyResource(cacheKey);
      clearTimeout(this.garbageCollectors.get(cacheKey));
      if (cacheData) {
        const timeLeft = cacheData.garbageCollection + cacheData.timestamp - +new Date();
        if (cacheData.garbageCollection !== null && JSON.stringify(cacheData.garbageCollection) === "null") {
          this.logger.info("Cache value is Infinite", { cacheKey });
        } else if (timeLeft >= 0) {
          this.garbageCollectors.set(
            cacheKey,
            setTimeout(() => {
              if (this.client.appManager.isOnline) {
                this.logger.info("Garbage collecting cache element", { cacheKey });
                this.delete(cacheKey);
              }
            }, timeLeft)
          );
        } else if (this.client.appManager.isOnline) {
          this.logger.info("Garbage collecting cache element", { cacheKey });
          this.delete(cacheKey);
        }
      }
    });
    this.clear = () => __async(this, null, function* () {
      this.storage.clear();
    });
    var _a, _b, _c, _d, _e;
    this.storage = ((_a = this.options) == null ? void 0 : _a.storage) || /* @__PURE__ */ new Map();
    this.events = getCacheEvents(this.emitter);
    (_c = (_b = this.options) == null ? void 0 : _b.onInitialization) == null ? void 0 : _c.call(_b, this);
    this.clearKey = ((_d = this.options) == null ? void 0 : _d.clearKey) || "";
    this.lazyStorage = (_e = this.options) == null ? void 0 : _e.lazyStorage;
    this.logger = this.client.loggerManager.init("Cache");
    this.getLazyKeys().then((keys) => {
      keys.forEach(this.scheduleGarbageCollector);
    });
    this.client.appManager.events.onOnline(() => {
      this.getLazyKeys().then((keys) => {
        keys.forEach(this.scheduleGarbageCollector);
      });
    });
  }
};

// src/cache/cache.utils.ts
var getCacheData = (previousResponse, response) => {
  const { data, success } = response;
  const previousData = !success && previousResponse ? previousResponse.data : null;
  const computedData = data || previousData;
  return __spreadProps(__spreadValues({}, response), { data: computedData });
};
var getInvalidateEventKey = (key) => {
  return `${key}_invalidate`;
};
var getCacheKey = (key) => {
  return `${key}_cache`;
};
var getCacheIdKey = (key) => {
  return `${key}_cache_by_id`;
};

// src/cache/cache.events.ts
var getCacheEvents = (emitter) => ({
  emitCacheData: (cacheKey, data) => {
    emitter.emit(getCacheKey(cacheKey), data);
  },
  emitInvalidation: (cacheKey) => {
    emitter.emit(getInvalidateEventKey(cacheKey));
  },
  onData: (cacheKey, callback) => {
    emitter.on(getCacheKey(cacheKey), callback);
    return () => emitter.removeListener(getCacheKey(cacheKey), callback);
  },
  onInvalidate: (cacheKey, callback) => {
    emitter.on(getInvalidateEventKey(cacheKey), callback);
    return () => emitter.removeListener(getInvalidateEventKey(cacheKey), callback);
  }
});

// src/managers/app/app.manager.ts
import EventEmitter3 from "events";
var AppManager = class {
  constructor(options) {
    this.options = options;
    this.emitter = new EventEmitter3();
    this.events = getAppManagerEvents(this.emitter);
    this.setInitialFocus = (initValue) => __async(this, null, function* () {
      if (typeof initValue === "function") {
        this.isFocused = false;
        this.isFocused = yield initValue();
      } else {
        this.isFocused = initValue;
      }
    });
    this.setInitialOnline = (initValue) => __async(this, null, function* () {
      if (typeof initValue === "function") {
        this.isOnline = false;
        this.isOnline = yield initValue();
      } else {
        this.isOnline = initValue;
      }
    });
    this.setFocused = (isFocused) => {
      this.isFocused = isFocused;
      if (isFocused) {
        this.events.emitFocus();
      } else {
        this.events.emitBlur();
      }
    };
    this.setOnline = (isOnline) => {
      this.isOnline = isOnline;
      if (isOnline) {
        this.events.emitOnline();
      } else {
        this.events.emitOffline();
      }
    };
    const {
      focusEvent = appManagerInitialOptions.focusEvent,
      onlineEvent = appManagerInitialOptions.onlineEvent,
      initiallyFocused = appManagerInitialOptions.initiallyFocused,
      initiallyOnline = appManagerInitialOptions.initiallyOnline
    } = this.options || appManagerInitialOptions;
    this.setInitialFocus(initiallyFocused);
    this.setInitialOnline(initiallyOnline);
    focusEvent(this.setFocused);
    onlineEvent(this.setOnline);
    this.isBrowser = hasDocument();
  }
};

// src/managers/app/app.manager.utils.ts
var hasWindow = () => {
  try {
    return Boolean(window && window.addEventListener);
  } catch (err) {
    return false;
  }
};
var hasDocument = () => {
  try {
    return Boolean(hasWindow() && window.document && window.document.addEventListener);
  } catch (err) {
    return false;
  }
};
var onWindowEvent = (key, listener, options) => {
  if (hasWindow()) {
    window.addEventListener(key, listener, options);
  }
};
var onDocumentEvent = (key, listener, options) => {
  if (hasDocument()) {
    window.document.addEventListener(key, listener, options);
  }
};

// src/managers/app/app.manager.events.ts
var getAppManagerEvents = (emitter) => ({
  emitFocus: () => {
    emitter.emit("focus" /* focus */);
  },
  emitBlur: () => {
    emitter.emit("blur" /* blur */);
  },
  emitOnline: () => {
    emitter.emit("online" /* online */);
  },
  emitOffline: () => {
    emitter.emit("offline" /* offline */);
  },
  onFocus: (callback) => {
    emitter.on("focus" /* focus */, callback);
    return () => emitter.removeListener("focus" /* focus */, callback);
  },
  onBlur: (callback) => {
    emitter.on("blur" /* blur */, callback);
    return () => emitter.removeListener("blur" /* blur */, callback);
  },
  onOnline: (callback) => {
    emitter.on("online" /* online */, callback);
    return () => emitter.removeListener("online" /* online */, callback);
  },
  onOffline: (callback) => {
    emitter.on("offline" /* offline */, callback);
    return () => emitter.removeListener("offline" /* offline */, callback);
  }
});

// src/managers/app/app.manager.constants.ts
var AppEvents = /* @__PURE__ */ ((AppEvents2) => {
  AppEvents2["focus"] = "focus";
  AppEvents2["blur"] = "blur";
  AppEvents2["online"] = "online";
  AppEvents2["offline"] = "offline";
  return AppEvents2;
})(AppEvents || {});
var appManagerInitialOptions = {
  initiallyFocused: true,
  initiallyOnline: true,
  focusEvent: (setFocused) => {
    onDocumentEvent("visibilitychange", () => setFocused(true));
    onWindowEvent("focus", () => setFocused(true));
    onWindowEvent("blur", () => setFocused(false));
  },
  onlineEvent: (setOnline) => {
    onWindowEvent("online", () => setOnline(true));
    onWindowEvent("offline", () => setOnline(false));
  }
};

// src/managers/request/request.manager.ts
import EventEmitter4 from "events";
var RequestManager = class {
  constructor() {
    this.emitter = new EventEmitter4();
    this.events = getRequestManagerEvents(this.emitter);
    this.abortControllers = /* @__PURE__ */ new Map();
    this.addAbortController = (abortKey, requestId) => {
      let abortGroup = this.abortControllers.get(abortKey);
      if (!abortGroup) {
        const newAbortGroup = /* @__PURE__ */ new Map();
        abortGroup = newAbortGroup;
        this.abortControllers.set(abortKey, newAbortGroup);
      }
      const abortController = abortGroup.get(requestId);
      if (!abortController || abortController.signal.aborted) {
        abortGroup.set(requestId, new AbortController());
      }
    };
    this.getAbortController = (abortKey, requestId) => {
      var _a;
      return (_a = this.abortControllers.get(abortKey)) == null ? void 0 : _a.get(requestId);
    };
    this.removeAbortController = (abortKey, requestId) => {
      var _a;
      (_a = this.abortControllers.get(abortKey)) == null ? void 0 : _a.delete(requestId);
    };
    this.useAbortController = (abortKey, requestId) => {
      var _a;
      const controller = (_a = this.abortControllers.get(abortKey)) == null ? void 0 : _a.get(requestId);
      controller == null ? void 0 : controller.abort();
    };
    this.abortByKey = (abortKey) => {
      const controllers = this.abortControllers.get(abortKey);
      if (controllers) {
        const entries = Array.from(controllers.entries());
        entries.forEach(([key]) => {
          this.useAbortController(abortKey, key);
        });
      }
    };
    this.abortByRequestId = (abortKey, requestId) => {
      this.useAbortController(abortKey, requestId);
    };
    this.abortAll = () => {
      const entries = Array.from(this.abortControllers.entries());
      entries.forEach(([abortKey, value]) => {
        const controllers = Array.from(value.entries());
        controllers.forEach(([requestId]) => {
          this.useAbortController(abortKey, requestId);
        });
      });
    };
  }
};

// src/managers/request/request.manager.utils.ts
var getLoadingEventKey = (key) => `${key}-loading-event`;
var getLoadingIdEventKey = (key) => `${key}-loading-event-by-id`;
var getRemoveEventKey = (key) => `${key}-remove-event`;
var getRemoveIdEventKey = (key) => `${key}-remove-event-by-id`;
var getAbortEventKey = (key) => `${key}-request-abort`;
var getAbortByIdEventKey = (key) => `${key}-request-abort-by-id`;
var getResponseEventKey = (key) => `${key}-response`;
var getResponseIdEventKey = (key) => `${key}-response-by-id`;
var getRequestStartEventKey = (key) => `${key}-request-start`;
var getRequestStartIdEventKey = (key) => `${key}-request-start-by-id`;
var getResponseStartEventKey = (key) => `${key}-response-start`;
var getResponseStartIdEventKey = (key) => `${key}-response-start-by-id`;
var getUploadProgressEventKey = (key) => `${key}-request-progress`;
var getUploadProgressIdEventKey = (key) => `${key}-request-progress-by-id`;
var getDownloadProgressEventKey = (key) => `${key}-response-progress`;
var getDownloadProgressIdEventKey = (key) => `${key}-response-progress-by-id`;

// src/managers/request/request.manager.events.ts
var getRequestManagerEvents = (emitter) => ({
  emitLoading: (queueKey, requestId, values) => {
    emitter.emit(getLoadingIdEventKey(requestId), values);
    emitter.emit(getLoadingEventKey(queueKey), values);
  },
  emitRequestStart: (queueKey, requestId, details) => {
    emitter.emit(getRequestStartIdEventKey(requestId), details);
    emitter.emit(getRequestStartEventKey(queueKey), details);
  },
  emitResponseStart: (queueKey, requestId, details) => {
    emitter.emit(getResponseStartIdEventKey(requestId), details);
    emitter.emit(getResponseStartEventKey(queueKey), details);
  },
  emitUploadProgress: (queueKey, requestId, values, details) => {
    emitter.emit(getUploadProgressIdEventKey(requestId), values, details);
    emitter.emit(getUploadProgressEventKey(queueKey), values, details);
  },
  emitDownloadProgress: (queueKey, requestId, values, details) => {
    emitter.emit(getDownloadProgressIdEventKey(requestId), values, details);
    emitter.emit(getDownloadProgressEventKey(queueKey), values, details);
  },
  emitResponse: (cacheKey, requestId, response, details) => {
    emitter.emit(getResponseIdEventKey(requestId), response, details);
    emitter.emit(getResponseEventKey(cacheKey), response, details);
  },
  emitAbort: (abortKey, requestId, request) => {
    emitter.emit(getAbortByIdEventKey(requestId), request);
    emitter.emit(getAbortEventKey(abortKey), request);
  },
  emitRemove: (queueKey, requestId, details) => {
    emitter.emit(getRemoveEventKey(queueKey), details);
    emitter.emit(getRemoveIdEventKey(requestId), details);
  },
  onLoading: (queueKey, callback) => {
    emitter.on(getLoadingEventKey(queueKey), callback);
    return () => emitter.removeListener(getLoadingEventKey(queueKey), callback);
  },
  onLoadingById: (requestId, callback) => {
    emitter.on(getLoadingIdEventKey(requestId), callback);
    return () => emitter.removeListener(getLoadingIdEventKey(requestId), callback);
  },
  onRequestStart: (queueKey, callback) => {
    emitter.on(getRequestStartEventKey(queueKey), callback);
    return () => emitter.removeListener(getRequestStartEventKey(queueKey), callback);
  },
  onRequestStartById: (requestId, callback) => {
    emitter.on(getRequestStartIdEventKey(requestId), callback);
    return () => emitter.removeListener(getRequestStartIdEventKey(requestId), callback);
  },
  onResponseStart: (queueKey, callback) => {
    emitter.on(getResponseStartEventKey(queueKey), callback);
    return () => emitter.removeListener(getResponseStartEventKey(queueKey), callback);
  },
  onResponseStartById: (requestId, callback) => {
    emitter.on(getResponseStartIdEventKey(requestId), callback);
    return () => emitter.removeListener(getResponseStartIdEventKey(requestId), callback);
  },
  onUploadProgress: (queueKey, callback) => {
    emitter.on(getUploadProgressEventKey(queueKey), callback);
    return () => emitter.removeListener(getUploadProgressEventKey(queueKey), callback);
  },
  onUploadProgressById: (requestId, callback) => {
    emitter.on(getUploadProgressIdEventKey(requestId), callback);
    return () => emitter.removeListener(getUploadProgressIdEventKey(requestId), callback);
  },
  onDownloadProgress: (queueKey, callback) => {
    emitter.on(getDownloadProgressEventKey(queueKey), callback);
    return () => emitter.removeListener(getDownloadProgressEventKey(queueKey), callback);
  },
  onDownloadProgressById: (requestId, callback) => {
    emitter.on(getDownloadProgressIdEventKey(requestId), callback);
    return () => emitter.removeListener(getDownloadProgressIdEventKey(requestId), callback);
  },
  onResponse: (cacheKey, callback) => {
    emitter.on(getResponseEventKey(cacheKey), callback);
    return () => emitter.removeListener(getResponseEventKey(cacheKey), callback);
  },
  onResponseById: (requestId, callback) => {
    emitter.on(getResponseIdEventKey(requestId), callback);
    return () => emitter.removeListener(getResponseIdEventKey(requestId), callback);
  },
  onAbort: (abortKey, callback) => {
    emitter.on(getAbortEventKey(abortKey), callback);
    return () => emitter.removeListener(getAbortEventKey(abortKey), callback);
  },
  onAbortById: (requestId, callback) => {
    emitter.on(getAbortByIdEventKey(requestId), callback);
    return () => emitter.removeListener(getAbortByIdEventKey(requestId), callback);
  },
  onRemove: (queueKey, callback) => {
    emitter.on(getRemoveEventKey(queueKey), callback);
    return () => emitter.removeListener(getRemoveEventKey(queueKey), callback);
  },
  onRemoveById: (requestId, callback) => {
    emitter.on(getRemoveIdEventKey(requestId), callback);
    return () => emitter.removeListener(getRemoveIdEventKey(requestId), callback);
  }
});

// src/managers/logger/logger.manager.ts
import EventEmitter5 from "events";
var LoggerManager = class {
  constructor(client, options) {
    this.client = client;
    this.options = options;
    this.emitter = new EventEmitter5();
    this.setSeverity = (severity2) => {
      this.severity = severity2;
    };
    this.init = (module) => {
      return {
        error: (message, ...extra) => {
          this.logger({
            level: "error",
            module,
            message,
            extra,
            severity: this.severity,
            enabled: this.client.debug
          });
        },
        warning: (message, ...extra) => {
          this.logger({
            level: "warning",
            module,
            message,
            extra,
            severity: this.severity,
            enabled: this.client.debug
          });
        },
        info: (message, ...extra) => {
          this.logger({
            level: "info",
            module,
            message,
            extra,
            severity: this.severity,
            enabled: this.client.debug
          });
        },
        debug: (message, ...extra) => {
          this.logger({
            level: "debug",
            module,
            message,
            extra,
            severity: this.severity,
            enabled: this.client.debug
          });
        }
      };
    };
    var _a, _b;
    this.logger = ((_a = this.options) == null ? void 0 : _a.logger) || logger;
    this.severity = ((_b = this.options) == null ? void 0 : _b.severity) || 2;
  }
};

// src/managers/logger/logger.manager.utils.ts
var getTime = () => {
  const d = new Date();
  return `${d.toLocaleTimeString()}(:${d.getMilliseconds()})`;
};
var logger = (log) => {
  var _a;
  if (log.enabled && log.severity >= severity[log.level]) {
    const styles = loggerStyles[log.level];
    const emoji = loggerIconLevels[log.level];
    const module = `%c[${log.module}]:[${getTime()}]:`;
    const message = `${emoji}${module} ${log.message}`;
    if ((_a = log.extra) == null ? void 0 : _a.length) {
      console.groupCollapsed(message, styles);
      log.extra.forEach((data) => {
        console.log(data);
      });
      console.groupEnd();
    } else {
      console.log(message, styles);
    }
  }
};

// src/managers/logger/logger.manager.constants.ts
var defaultStyles = "background:rgba(0,0,0,0.2);padding:2px 5px;border-radius:5px;font-weight:bold;";
var loggerStyles = {
  error: `${defaultStyles}color:#db2525`,
  warning: `${defaultStyles}color:#e1941e`,
  info: `${defaultStyles}color:#1e74e1`,
  debug: `${defaultStyles}color:#adadad`
};
var loggerIconLevels = {
  error: `\u{1F6A8}`,
  warning: `\u{1F6A7}`,
  info: `\u2139\uFE0F`,
  debug: `\u{1F6E9}\uFE0F`
};
var severity = {
  error: 0,
  warning: 1,
  info: 2,
  debug: 3
};

// src/client/client.utils.ts
var stringifyValue = (response) => {
  try {
    return JSON.stringify(response);
  } catch (err) {
    return "";
  }
};
var interceptRequest = (interceptors, request) => __async(void 0, null, function* () {
  let newRequest = request;
  if (!request.requestOptions.disableRequestInterceptors) {
    for (const interceptor of interceptors) {
      newRequest = yield interceptor(request);
      if (!newRequest)
        throw new Error("Request modifier must return request");
    }
  }
  return newRequest;
});
var interceptResponse = (interceptors, response, request) => __async(void 0, null, function* () {
  let newResponse = response;
  if (!request.requestOptions.disableResponseInterceptors) {
    for (const interceptor of interceptors) {
      newResponse = yield interceptor(response, request);
      if (!newResponse)
        throw new Error("Response modifier must return data");
    }
  }
  return newResponse;
});
var getAdapterHeaders = (request) => {
  const isFormData = hasWindow() && request.data instanceof FormData;
  const headers = {};
  if (!isFormData)
    headers["Content-Type"] = "application/json";
  Object.assign(headers, request.headers);
  return headers;
};
var getAdapterPayload = (data) => {
  const isFormData = hasWindow() && data instanceof FormData;
  if (isFormData)
    return data;
  return stringifyValue(data);
};
var isValidValue = (options) => {
  return (value) => {
    const { skipNull, skipEmptyString } = options;
    if (skipEmptyString && value === void 0) {
      return false;
    }
    if (skipEmptyString && value === "") {
      return false;
    }
    if (skipNull && value === null) {
      return false;
    }
    return true;
  };
};
var encodeValue = (value, { encode, strict }) => {
  if (encode && strict) {
    return encodeURIComponent(value).replace(/[!'()*]/g, (s) => `%${s.charCodeAt(0).toString(16).toUpperCase()}`);
  }
  if (encode) {
    return encodeURIComponent(value);
  }
  return value;
};
var encodeParams = (key, value, options) => {
  const shouldSkip = !isValidValue(options)(value);
  if (!key || shouldSkip) {
    return "";
  }
  const parsedValue = () => {
    var _a, _b;
    if (value instanceof Date) {
      return ((_a = options.dateParser) == null ? void 0 : _a.call(options, value)) || value.toISOString();
    }
    if (typeof value === "object" && !Array.isArray(value)) {
      return ((_b = options.objectParser) == null ? void 0 : _b.call(options, value)) || JSON.stringify(value);
    }
    return String(value);
  };
  return `${encodeValue(key, options)}=${encodeValue(parsedValue(), options)}`;
};
var encodeArray = (key, array, options) => {
  const { arrayFormat, arraySeparator } = options;
  return array.filter(isValidValue(options)).reduce((acc, value, index) => {
    switch (arrayFormat) {
      case "index": {
        const keyValue = `${encodeValue(key, options)}[${encodeValue(String(index), options)}]=`;
        acc.push(`${keyValue}${encodeValue(String(value), options)}`);
        break;
      }
      case "bracket": {
        const keyValue = `${encodeValue(key, options)}[]=`;
        acc.push(`${keyValue}${encodeValue(String(value), options)}`);
        break;
      }
      case "comma": {
        const keyValue = !acc.length && `${encodeValue(key, options)}=` || "";
        return [[...acc, `${keyValue}${encodeValue(String(value), options)}`].join(",")];
      }
      case "separator": {
        const keyValue = !acc.length && `${encodeValue(key, options)}=` || "";
        return [[...acc, `${keyValue}${encodeValue(String(value), options)}`].join(arraySeparator || "|")];
      }
      case "bracket-separator": {
        const keyValue = !acc.length && `${encodeValue(key, options)}[]=` || "";
        return [[...acc, `${keyValue}${encodeValue(String(value), options)}`].join(arraySeparator || "|")];
      }
      default: {
        const keyValue = `${encodeValue(key, options)}=`;
        acc.push(`${keyValue}${encodeValue(String(value), options)}`);
      }
    }
    return acc;
  }, []).join("&");
};
var stringifyQueryParams = (queryParams, options = stringifyDefaultOptions) => {
  if (!queryParams || !Object.keys(queryParams).length) {
    return "";
  }
  if (typeof queryParams === "string") {
    const hasQuestionMark = queryParams[0] === "?";
    return hasQuestionMark ? queryParams : `?${queryParams}`;
  }
  const stringified = Object.entries(queryParams).map(([key, value]) => {
    if (Array.isArray(value)) {
      return encodeArray(key, value, options);
    }
    return encodeParams(key, value, options);
  }).filter(Boolean).join("&");
  if (stringified) {
    return `?${stringified}`;
  }
  return "";
};

// src/client/client.ts
var Client = class {
  constructor(options) {
    this.options = options;
    this.__onErrorCallbacks = [];
    this.__onSuccessCallbacks = [];
    this.__onResponseCallbacks = [];
    this.__onAuthCallbacks = [];
    this.__onRequestCallbacks = [];
    this.requestManager = new RequestManager();
    this.loggerManager = new LoggerManager(this);
    this.defaultMethod = "GET" /* get */;
    this.defaultExtra = xhrExtra;
    this.isMockEnabled = true;
    this.effects = [];
    this.abortKeyMapper = getSimpleKey;
    this.cacheKeyMapper = getRequestKey;
    this.queueKeyMapper = getRequestKey;
    this.effectKeyMapper = getSimpleKey;
    this.stringifyQueryParams = (queryParams) => stringifyQueryParams(queryParams, this.queryParamsConfig);
    this.headerMapper = getAdapterHeaders;
    this.payloadMapper = getAdapterPayload;
    this.endpointMapper = (endpoint) => endpoint;
    this.logger = this.loggerManager.init("Client");
    this.setRequestDefaultOptions = (callback) => {
      this.requestDefaultOptions = callback;
      return this;
    };
    this.setAdapterDefaultOptions = (callback) => {
      this.adapterDefaultOptions = callback;
      return this;
    };
    this.setDebug = (debug) => {
      this.debug = debug;
      return this;
    };
    this.setLoggerSeverity = (severity2) => {
      this.loggerManager.setSeverity(severity2);
      return this;
    };
    this.setLogger = (callback) => {
      this.loggerManager = callback(this);
      return this;
    };
    this.setQueryParamsConfig = (queryParamsConfig) => {
      this.queryParamsConfig = queryParamsConfig;
      return this;
    };
    this.setStringifyQueryParams = (stringifyFn) => {
      this.stringifyQueryParams = stringifyFn;
      return this;
    };
    this.setHeaderMapper = (headerMapper) => {
      this.headerMapper = headerMapper;
      return this;
    };
    this.setPayloadMapper = (payloadMapper) => {
      this.payloadMapper = payloadMapper;
      return this;
    };
    this.setEnableGlobalMocking = (isMockEnabled) => {
      this.isMockEnabled = isMockEnabled;
      return this;
    };
    this.setEndpointMapper = (endpointMapper) => {
      this.endpointMapper = endpointMapper;
      return this;
    };
    this.setAdapter = (callback) => {
      const value = callback(this);
      if (value instanceof Client) {
        return value;
      }
      this.adapter = value;
      return this;
    };
    this.setDefaultMethod = (defaultMethod) => {
      this.defaultMethod = defaultMethod;
      return this;
    };
    this.setDefaultExtra = (defaultExtra) => {
      this.defaultExtra = defaultExtra;
      return this;
    };
    this.onAuth = (callback) => {
      this.__onAuthCallbacks.push(callback);
      return this;
    };
    this.removeOnAuthInterceptors = (callbacks) => {
      this.__onAuthCallbacks = this.__onAuthCallbacks.filter((callback) => !callbacks.includes(callback));
      return this;
    };
    this.onError = (callback) => {
      this.__onErrorCallbacks.push(callback);
      return this;
    };
    this.removeOnErrorInterceptors = (callbacks) => {
      this.__onErrorCallbacks = this.__onErrorCallbacks.filter((callback) => !callbacks.includes(callback));
      return this;
    };
    this.onSuccess = (callback) => {
      this.__onSuccessCallbacks.push(callback);
      return this;
    };
    this.removeOnSuccessInterceptors = (callbacks) => {
      this.__onSuccessCallbacks = this.__onSuccessCallbacks.filter((callback) => !callbacks.includes(callback));
      return this;
    };
    this.onRequest = (callback) => {
      this.__onRequestCallbacks.push(callback);
      return this;
    };
    this.removeOnRequestInterceptors = (callbacks) => {
      this.__onRequestCallbacks = this.__onRequestCallbacks.filter((callback) => !callbacks.includes(callback));
      return this;
    };
    this.onResponse = (callback) => {
      this.__onResponseCallbacks.push(callback);
      return this;
    };
    this.removeOnResponseInterceptors = (callbacks) => {
      this.__onResponseCallbacks = this.__onResponseCallbacks.filter((callback) => !callbacks.includes(callback));
      return this;
    };
    this.addEffect = (effect) => {
      this.effects = this.effects.concat(effect);
      return this;
    };
    this.removeEffect = (effect) => {
      const name = typeof effect === "string" ? effect : effect.getEffectKey();
      this.effects = this.effects.filter((currentEffect) => currentEffect.getEffectKey() !== name);
      return this;
    };
    this.setAbortKeyMapper = (callback) => {
      this.abortKeyMapper = callback;
    };
    this.setCacheKeyMapper = (callback) => {
      this.cacheKeyMapper = callback;
    };
    this.setQueueKeyMapper = (callback) => {
      this.queueKeyMapper = callback;
    };
    this.setEffectKeyMapper = (callback) => {
      this.effectKeyMapper = callback;
    };
    this.__modifyAuth = (request) => __async(this, null, function* () {
      return interceptRequest(this.__onAuthCallbacks, request);
    });
    this.__modifyRequest = (request) => __async(this, null, function* () {
      return interceptRequest(this.__onRequestCallbacks, request);
    });
    this.__modifyErrorResponse = (response, request) => __async(this, null, function* () {
      return interceptResponse(this.__onErrorCallbacks, response, request);
    });
    this.__modifySuccessResponse = (response, request) => __async(this, null, function* () {
      return interceptResponse(this.__onSuccessCallbacks, response, request);
    });
    this.__modifyResponse = (response, request) => __async(this, null, function* () {
      return interceptResponse(this.__onResponseCallbacks, response, request);
    });
    this.clear = () => {
      const { appManager, cache, fetchDispatcher, submitDispatcher } = this.options;
      this.requestManager.abortControllers.clear();
      this.fetchDispatcher.clear();
      this.submitDispatcher.clear();
      this.cache.clear();
      this.requestManager.emitter.removeAllListeners();
      this.fetchDispatcher.emitter.removeAllListeners();
      this.submitDispatcher.emitter.removeAllListeners();
      this.cache.emitter.removeAllListeners();
      this.appManager = (appManager == null ? void 0 : appManager(this)) || new AppManager();
      this.cache = (cache == null ? void 0 : cache(this)) || new Cache(this);
      this.fetchDispatcher = (fetchDispatcher == null ? void 0 : fetchDispatcher(this)) || new Dispatcher(this);
      this.submitDispatcher = (submitDispatcher == null ? void 0 : submitDispatcher(this)) || new Dispatcher(this);
    };
    this.createRequest = () => {
      return (params) => {
        const endpoint = this.endpointMapper(params.endpoint);
        const mappedParams = __spreadProps(__spreadValues({}, params), {
          endpoint
        });
        return new Request(this, mappedParams);
      };
    };
    const { url, adapter: adapter3, appManager, cache, fetchDispatcher, submitDispatcher } = this.options;
    this.url = url;
    this.adapter = adapter3 || adapter2;
    this.appManager = (appManager == null ? void 0 : appManager(this)) || new AppManager();
    this.cache = (cache == null ? void 0 : cache(this)) || new Cache(this);
    this.fetchDispatcher = (fetchDispatcher == null ? void 0 : fetchDispatcher(this)) || new Dispatcher(this);
    this.submitDispatcher = (submitDispatcher == null ? void 0 : submitDispatcher(this)) || new Dispatcher(this);
  }
};

// src/client/client.constants.ts
var stringifyDefaultOptions = {
  strict: true,
  encode: true,
  arrayFormat: "bracket",
  arraySeparator: "bracket",
  sort: false,
  skipNull: true,
  skipEmptyString: true
};
export {
  AppEvents,
  AppManager,
  Cache,
  Client,
  DateInterval,
  Dispatcher,
  DispatcherRequestType,
  HttpMethodsEnum,
  LoggerManager,
  Request,
  RequestEffect,
  RequestManager,
  adapter2 as adapter,
  appManagerInitialOptions,
  canRetryRequest,
  defaultTimeout,
  getAbortByIdEventKey,
  getAbortEventKey,
  getAdapterBindings,
  getAdapterHeaders,
  getAdapterPayload,
  getAppManagerEvents,
  getCacheData,
  getCacheEvents,
  getCacheIdKey,
  getCacheKey,
  getDispatcherChangeEventKey,
  getDispatcherDrainedEventKey,
  getDispatcherEvents,
  getDispatcherStatusEventKey,
  getDownloadProgressEventKey,
  getDownloadProgressIdEventKey,
  getErrorMessage,
  getInvalidateEventKey,
  getIsEqualTimestamp,
  getLoadingEventKey,
  getLoadingIdEventKey,
  getProgressData,
  getProgressValue,
  getRemoveEventKey,
  getRemoveIdEventKey,
  getRequestDispatcher,
  getRequestEta,
  getRequestKey,
  getRequestManagerEvents,
  getRequestStartEventKey,
  getRequestStartIdEventKey,
  getRequestType,
  getResponseEventKey,
  getResponseHeaders,
  getResponseIdEventKey,
  getResponseStartEventKey,
  getResponseStartIdEventKey,
  getSimpleKey,
  getTime,
  getUniqueRequestId,
  getUploadProgressEventKey,
  getUploadProgressIdEventKey,
  hasDocument,
  hasWindow,
  interceptRequest,
  interceptResponse,
  logger,
  loggerIconLevels,
  loggerStyles,
  mocker,
  onDocumentEvent,
  onWindowEvent,
  parseErrorResponse,
  parseResponse,
  sendRequest,
  severity,
  stringifyDefaultOptions,
  stringifyKey,
  stringifyQueryParams,
  stringifyValue,
  xhrExtra
};
//# sourceMappingURL=index.esm.js.map
